package mediateca;

import java.io.*;
import java.util.*;

public class Mediateca
{
	Map<String, List<Media>> media = new HashMap<String, List<Media>>();
	Map<String, Comparator<Media>> comparatori = new HashMap<String, Comparator<Media>>();

	public static void main(String[] argv)
	{
		(new Mediateca()).exec(argv);
	}

	void exec(String[] argv)
	{
		Comparator<Media> tmp = new ComparaMediaPerCategoria();
		comparatori.put("per categoria", tmp);
		tmp = new ComparaMediaPerCategoriaETitolo();
		comparatori.put("per categoria e titolo", tmp);

		//il menu con i comandi
		Scanner stdin = new Scanner(System.in);

		while(true)
		{
			System.out.print("Comando [leggi/stampa/esci] ? > ");
			String cmd = null;

			cmd = stdin.nextLine();

			if(cmd.equals("esci"))
			{
				return;
			}
			else if(cmd.equals("leggi"))
			{
				leggi(stdin);
			}
			else if(cmd.equals("stampa"))
			{
				stampa(stdin);
			}
			else
			{
				System.out.println("Comando <" + cmd + "> non riconosciuto");
			}
		}
	}

	void leggi(Scanner sin)
	{
		System.out.print("Nome file ? > ");
		String nome = sin.nextLine();
		Scanner sfile = null;
		try
		{
			sfile = new Scanner(new File(nome));
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
			return;
		}

		//Precondizione: il file deve essere formattato correttamente
		while(sfile.hasNextLine())
		{
			String tipo = sfile.nextLine();
			Media mtmp = null;
			if(tipo.equals("Dvd"))
			{
				String c = sfile.nextLine();
				String t = sfile.nextLine();
				String r = sfile.nextLine();
				int a = Integer.parseInt(sfile.nextLine());
				String cas = sfile.nextLine();
				mtmp = new Dvd(c, t, r, a, cas);
			}
			else
			{
				System.out.println("Media tipo <" + tipo + "> non gestito");
				continue;
			}

			String key = mtmp.getClass().getName();
			List<Media> l = media.get(key);
			if(l == null)
			{
				l = new LinkedList<Media>();
				media.put(key, l);
			}
			l.add(mtmp);
		}
		sfile.close();
	}

	void stampa(Scanner sin)
	{
		System.out.print("Tipo media [" + media.keySet() + "] ? >");
		String tipo = sin.nextLine();
		System.out.print("Tipo ordinamento [Titolo," + comparatori.keySet() + "] ? > ");
		String tipoOrd = sin.nextLine();

		List<Media> lista = media.get(tipo);
		Comparator<Media> comp = comparatori.get(tipoOrd);
		if(lista == null)
		{
			System.out.println("Non ci sono media di tipo <" + tipo + ">");
			return;
		}
		Collections.sort(lista, comp);
		System.out.println(lista);
	}
}
